﻿local GarrisonDone = ...

if (not GarrisonDone_Varsm) then GarrisonDone_Varsm = {} end

if (not GarrisonDoneFrame) then GarrisonDoneFrame = GarrisonDoneFrame end
    

local playerName = UnitName("player");

C_Timer.After(30, function() GarrisonDone_minimap(self, mgdLDB) end)
                        
            -- LDB LAUNCHER and LDB MINIMAP ICON --
local GarrisonDone_Varsc = _G.GarrisonDone_Varsc
local mgdLDB = LibStub:GetLibrary("LibDataBroker-1.1")
local icon = LibStub("LibDBIcon-1.0")

        
            -- LDB --    
local mgdLDB = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("GarrisonDone", {
            type = "data source",
	        text = "My Garrison",
            label = "My Garrison",
            tocname = "GarrisonDone",
            icon = "Interface\\AddOns\\GarrisonDone\\images\\MGDL.tga",
            OnClick = function(self, button, ...)
            if (button == "LeftButton") then
		    if GarrisonDoneFrame:IsShown() then
                GarrisonDoneFrame:Hide()
                GarrisonDoneOptEditFrame:Hide();
                GarrisonDoneEditFrame:Hide();
                GarrisonDoneBuildFrame:Hide();
                GarrisonDoneBuildScrollFrame:Hide();
                GarrisonDoneAltsFrame:Hide();
                GarrisonDoneAltsScrollFrame:Hide();
                GarrisonDoneOptEditFrame:Hide();
                else
                PanelTemplates_SetTab(GarrisonDoneFrame, 1);
                GarrisonDoneFrame:Show()
                GarrisonDoneEditFrame:Show();
                GarrisonDoneBuildFrame:Hide();
                GarrisonDoneBuildScrollFrame:Hide();
                GarrisonDoneAltsFrame:Hide();
                GarrisonDoneAltsScrollFrame:Hide();
                GarrisonDoneOptEditFrame:Hide();
                end
       	    elseif (button == "RightButton") then
            if GarrisonDoneOptEditFrame:IsShown() then
            PanelTemplates_SetTab(GarrisonDoneFrame, 1);
			GarrisonDoneEditFrame:Show();
            GarrisonDoneBuildFrame:Hide();
            GarrisonDoneBuildScrollFrame:Hide();
            GarrisonDoneAltsFrame:Hide();
            GarrisonDoneAltsScrollFrame:Hide();
            GarrisonDoneOptEditFrame:Hide();
            else
            GarrisonDoneFrame:Show()
            GarrisonDoneOptEditFrame:Show();
            GarrisonDoneEditFrame:Hide();
            GarrisonDoneBuildFrame:Hide();
            GarrisonDoneBuildScrollFrame:Hide();
            GarrisonDoneAltsFrame:Hide();
            GarrisonDoneAltsScrollFrame:Hide();
            GarrisonDone_OptionsOnShow(self);
            end
         end
    end
		    
    })
     
  
        -- Tablet --
        local mgdLDB_tablet	= AceLibrary("Tablet-2.0")
        local mgdldb_frame	= CreateFrame("frame")
        local GarrisonDone_Varsc = _G.GarrisonDone_Varsc
        
        -- Update Tablet Data --        
function mgdLDB:Update()   
            local GarrisonDone_Varsc = _G.GarrisonDone_Varsc
		    mgdLDB_tablet:SetHint("|cffffd200Left|r |cffffff00Click for My Garrison Panel. |cffffff00Right Click for Interface. |cffffff00Shift Right Click to Move MGD Button.")
            mgdLDB_tablet:SetTitle("My Garrison is Done")
            
            -- START GARRISON DATA --
            
            cat = mgdLDB_tablet:AddCategory('id', 'garrison', 'columns', 1, 'text', "")
                cat:AddLine('text', "---------------------------------------------------- ")
                cat:AddLine('text', "               |cffffffff"..playerName.."'s Garrison|r")
                cat:AddLine('text', " -------------------------------------------") 
		   -- Max Followers --
            local maxFollowers = C_Garrison.GetFollowerSoftCap();
                -- Active Followers --
            local numActiveFollowers = C_Garrison.GetNumActiveFollowers();
                -- Missions Available --
            local AvailableItems = C_Garrison.GetAvailableMissions();
                -- Missions Complete --
            local completeMissions = C_Garrison.GetCompleteMissions();
                -- Missions in Progress --
            local items = C_Garrison.GetLandingPageItems();  
            local mip = #items - #completeMissions;
                -- Mining Nodes --
            local ore = 0;
            if GarrisonDone_Varsc.hasMine == true then
		        if GarrisonDone_Varsc.miningLeft > 0 then
		        ore = format("%s", GarrisonDone_Varsc.miningLeft)
                tonumber(ore)
		        end
            end
            local ores = 0;
            if GarrisonDone_Varsc.hasMine == true then
		        if GarrisonDone_Varsc.maxMining > 0 then
		        ores = format("%s", GarrisonDone_Varsc.maxMining)
                tonumber(ores)
		        end
	        end 
                -- Herb Nodes --
            local herb = 0;
            if GarrisonDone_Varsc.hasGarden == true then
    	        if GarrisonDone_Varsc.herbingLeft > 0 then
		        herb = format("%s", GarrisonDone_Varsc.herbingLeft)
                tonumber(herb)
		        end
	        end 
            local herbs = 0;
            if GarrisonDone_Varsc.hasGarden == true then
		        if GarrisonDone_Varsc.maxHerbing > 0 then
		        herbs = format("%s", GarrisonDone_Varsc.maxHerbing)
                tonumber(herbs)
		        end
	        end
                -- Find all our Followers and Set Status --
            local followers = C_Garrison.GetFollowers();
                -- Followers working --
            local work = 0;
                for i = 1, #followers do
	            if ( followers[i].status == GARRISON_FOLLOWER_WORKING) then
		        work = work + 1;
                end
            end
                -- Followers on Missions --
            local gfm = 0;
                for i = 1, #followers do
	            if ( followers[i].status == GARRISON_FOLLOWER_ON_MISSION) then
		        gfm = gfm + 1;
                end
            end    
            local fBusy = gfm + work;
            local available = numActiveFollowers - fBusy;
                -- Garrison Resources --
            local _, currentAmount, _, _, _, _, _ = GetCurrencyInfo(824);
            
                -- PRINT GARRISON DATA --
                
                    -- Followers --
                if GarrisonDone_Varsc.ldbmiss ~= true then
                cat:AddLine('text', "      |cffFF8000Total Followers|cff007fff = |r"..numActiveFollowers.."|cff007fff/|cffFF8000"..maxFollowers.."");
                cat:AddLine('text', "   -----------------------------------------")   
                    -- Missions in Progress --
                    if mip ~= 0 then
		        cat:AddLine('text', "      Missions in Progress|cff007fff = |cffffffff"..mip.."");
                    elseif mip == 0 then
                cat:AddLine('text', "      |cffffffffMissions in Progress|cff007fff = |r|cffff0000"..mip.."");
                    end
                cat:AddLine('text', "   -----------------------------------------")
                    -- Complete Missions --
		        cat:AddLine('text', "      Missions Complete|cff007fff = |cff00aa00"..#completeMissions.."");
                    -- Missions Available --
		        cat:AddLine('text', "      Missions Available|cff007fff = |r"..#AvailableItems.."");
                cat:AddLine('text', "   -----------------------------------------")   
                    -- Followers Available --
		        cat:AddLine('text', "      Followers Available|cff007fff = |r"..available.."");
                    if available == 0 then
                cat:AddLine('text', "      Followers Available|cff007fff = |r|cff00aa00"..available.."");
                    elseif available > 25 then
                cat:AddLine('text', "      Followers Available|cff007fff = |r|cffff0000"..available.."");       
                    end
                    -- Followers Working
		        cat:AddLine('text', "      Followers Working|cff007fff = |r"..work.."");
                    -- Followers on Mission
                    if gfm ~= 0 then
	            cat:AddLine('text', "      Followers on Mission|cff007fff = |cffFF8000"..gfm.."");
                    else
                cat:AddLine('text', "      Followers on Mission|cff007fff = |cffff0000"..gfm.."");
                    end
                cat:AddLine('text', "   -----------------------------------------")   
                    -- Mining Nodes --
                    if ore ~= 0 then
		        cat:AddLine('text', "      Mining Nodes|cff007fff = |cffff0000"..ore.."|cff007fff/|cff00aa00"..ores.."");
                    elseif ore == 0 then
                cat:AddLine('text', "      Mining Nodes|cff007fff = |r"..ore.."|cff007fff/|cff00aa00"..ores.."");
                    end
                    -- Herb Nodes --
                    if herb ~= 0 then
		        cat:AddLine('text', "      Nice Flowers|cff007fff = |cffff0000"..herb.."|cff007fff/|cff00aa00"..herbs.."");
                    elseif herb == 0 then
                cat:AddLine('text', "      Nice Flowers|cff007fff = |r"..herb.."|cff007fff/|cff00aa00"..herbs.."");  
                    end
                cat:AddLine('text', "   -----------------------------------------")   
                    -- Garrison Resources --
		        cat:AddLine('text', "       Your Resources|cff007fff = |r"..currentAmount.."")
                cat:AddLine('text', "   -----------------------------------------")    
                end
            -- End Garrison Data --
            
            
            -- START MISSION DATA -- 
            cat = mgdLDB_tablet:AddCategory('id', 'garrison', 'columns', 1, 'text', "")
            cat:AddLine('text', "                      ALL MISSIONS")
            cat:AddLine('text', "---------------------------------------------------- ")
            cat:AddLine('text', "")
            cat:AddLine('text', "     |cffFF8000Name               Mission           Time|r")
            cat:AddLine('text', "---------------------------------------------------- ")
            
                    -- Gather Mission Data --
            GarrisonDoneAltsFrame_Update_Log = 0
		    if GarrisonDoneAltsFrame_Update_Log <= 0 then
			local i = 0
			local b = 0 
				if GarrisonDone_Vars then
					for realm, v1 in pairs(GarrisonDone_Vars) do
						for character, v2 in pairs(v1) do
							for index, data in pairs(v2) do
								i = i + 1
									local name = data.name
									local t = data.endTime - time()
								--	local bar, texture, label, altMGDLabel, object
									local missionID = data.missionID
								--	bar = _G["text"..b]
									
                                    local color = "|cffE6CC80"
                                        -- Set Class Colors --
                                    if data.isRare ~= true then 
                                    if data.class == "Death Knight" then color = "|cffC41F3B   "
                                    elseif data.class == "Druid" then color = "|cffFF7D0A   "
                                    elseif data.class == "Hunter" then color = "|cffABD473   "
                                    elseif data.class == "Mage" then color = "|cff69CCF0   "
                                    elseif data.class == "Monk" then color = "|cff00FF96   "
                                    elseif data.class == "Paladin" then color = "|cffF58CBA   "
                                    elseif data.class == "Priest" then color = "|cffFFFFFF   "
                                    elseif data.class == "Rogue" then color = "|cffFFF569   "
                                    elseif data.class == "Shaman" then color = "|cff0070DE   "
                                    elseif data.class == "Warlock" then color = "|cff9482C9   "
                                    elseif data.class == "Warrior" then color = "|cffC79C6E   "
                                        end
                                    end
                                        -- Change to Rare Blue for Rare Missions --
									if data.isRare == true then
                                    if data.class == "Death Knight" then color = "|cff0070FFR |cffC41F3B"
                                    elseif data.class == "Druid" then color = "|cff0070FFR |cffFF7D0A"
                                    elseif data.class == "Hunter" then color = "|cff0070FFR |cffABD473"
                                    elseif data.class == "Mage" then color = "|cff0070FFR |cff69CCF0"
                                    elseif data.class == "Monk" then color = "|cff0070FFR |cff00FF96"
                                    elseif data.class == "Paladin" then color = "|cff0070FFR |cffF58CBA"
                                    elseif data.class == "Priest" then color = "|cff0070FFR |cffFFFFFF"
                                    elseif data.class == "Rogue" then color = "|cff0070FFR |cffFFF569"
                                    elseif data.class == "Shaman" then color = "|cff0070FFR |cff0070DE"
                                    elseif data.class == "Warlock" then color = "|cff0070FFR |cff9482C9"
                                    elseif data.class == "Warrior" then color = "|cff0070FFR |cffC79C6E"
                                        end
                                    end
                    -- Print Mission Time --
                if t > 60 then
                if GarrisonDone_Varsc.ldbcomp ~= true then
		            cat:AddLine('text',	(string.format("%s: %02d:%02d", color..character.."-"..realm..": |cffE6CC80"..name:sub(1,15).." |cff00FAF6", floor(t/3600), floor(mod(t,3600)/60))))
                    cat:AddLine(
                        'text', "---------------------------------------------------- "
                        )
                    end
                else
                    -- Print Mission Ready --
                if data.detailedTime == false and realm == GetRealmName() and character == GetUnitName("player") then
			        GarrisonDone_UpdateData(data)
                end
		            cat:AddLine('text',	(string.format("%s: |cff1EFF0CReady", color..character.."-"..realm..": |cffE6CC80"..name:sub(1,15).."")))
                    cat:AddLine('text', "---------------------------------------------------- ")
                        end   
                    end
                end
            end
        end
    end
end

    -- Update LDB Data --
function mgdLDB_Update()
	GarrisonDone_UpdateData(data)
    GarrisonDone_Update(self)
end

mgdldb_frame:SetScript("OnUpdate", mgdLDB_Update) -- update for the faux frame we created for tablet --

            -- Show, Set and Positon the Tooltip Frame used by the Tablet --
function mgdLDB.OnEnter(self)
	if not mgdLDB_tablet:IsRegistered(self) then
		mgdLDB_tablet:Register(self,
			'children', function() mgdLDB:Update() end,
			'clickable', true,
			'point', function(mgdldb_frame)
					    if mgdldb_frame:GetTop() > GetScreenHeight() / 2 then
				        local x = mgdldb_frame:GetCenter()
	                    return "TOP", "BOTTOM"
                    end
				end,
			'dontHook', true
		)
	end
	mgdLDB_tablet:Open(self)
end
                -- END TABLET --
                

                -- LDBIcon --
 
LibStub("LibDBIcon-1.0"):Register("GarrisonDone", mgdLDB, GarrisonDone_Varsm.minimap)
 
   

function GarrisonDone_minimap(self, mgdLDB)
    local GarrisonDone_Varsm = _G.GarrisonDone_Varsm
    local GarrisonDone_Varsc = _G.GarrisonDone_Varsc
	if GarrisonDone_Varsm.minimap.hide == true then
		icon:Hide("GarrisonDone")
	else 
		icon:Show("GarrisonDone")
	end
end


        -- END LDB DISPLAY --     
        